

structure Translate :> TRANSLATE =
struct

structure M = TMinML
structure D = EDMinML

  exception TranslateError
  exception Unimplemented

  (* The empty environment. *)

  val empty = fn _ => raise TranslateError

  type (''a, 'b) env = ''a -> 'b

  (* ++ : (''a, 'b) env * (''a * 'b) -> (''a, 'b) env 
     g++(x,t) adds a variable x with type t to environment g. *)

  infix 1 ++
  fun (g ++ (x,t)) = fn x' => if x = x' then t else g(x')

  (* tagify : M.typ -> M.exp *)
  (* tagify tau ==> the tagifying function of type tau->Tagged. *)
  fun tagify _ = raise Unimplemented







  (* cast : M.typ -> M.exp *)
  (* cast tau ==> the casting function of type Tagged->tau. *)
  and cast _ = raise Unimplemented







  fun translateType D.INT = M.INT
    | translateType D.BOOL = M.BOOL
    | translateType (D.ARROW (t1,t2)) = M.ARROW (translateType t1,translateType t2)

  (* translateExp : (string,M.typ) env * D.exp -> M.exp * M.typ *)
  (* translateExp (G,e) ==> (e',tau)  where G |- e => e' : tau  *)
  fun translateExp (G,_) = raise Unimplemented





























































  (* translatePrimop : (string,M.typ) env * D.primop * (D.exp list) -> M.exp * M.typ *)
  (* translatePrimop (G,op,args) ==> (e,tau)  where G |- op(args) => e : tau.        *)
  and translatePrimop (G,oper,args) = raise Unimplemented




















  fun translate e = translateExp (empty,e)

end