signature EDPARSE =
sig

  (* parser for Extended Dynamic MinML programs.
   
     A MinML program is an expression followed by a semicolon;
     this function takes an input stream of tokens and returns
     a stream of programs (expressions).
   *)

  val parse : EDLexer.token Stream.stream -> EDMinML.exp Stream.stream


  exception ParseError of string

end
